.386
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib

.const
 id equ 3000
.data
 _wnd  db "window",0
 _btn  db "button",0
.data?
 hinst dd ?
 hwbtn dd ?
.code

WndProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
  local rt:RECT
	.if uMsg==WM_DESTROY
    invoke PostQuitMessage,0
	  xor eax,eax
	.elseif uMsg==WM_CREATE
	  invoke CreateWindowEx,0,offset _btn,offset _btn,WS_CHILD or WS_VISIBLE or WS_DISABLED,20,20,100,30,hWnd,id,hinst,0
	  mov hwbtn,eax
	  xor eax,eax	
  .elseif uMsg==WM_COMMAND && wParam==id
    invoke MessageBox,0,addr _btn,addr _wnd,0
    xor eax,eax
	.elseif uMsg==WM_LBUTTONDOWN
	  invoke GetWindowRect,hwbtn,addr rt
	  invoke MapWindowPoints,0,hWnd,addr rt,2
	  mov eax,lParam
	  mov ecx,eax
	  and eax,0ffffh
	  shr ecx,16
	  invoke PtInRect,addr rt,eax,ecx
	  test eax,eax
	  jz @f
    invoke SendMessage,hwbtn,uMsg,wParam,lParam
    xor eax,eax
	.else
@@:
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
	.endif
	ret
WndProc endp

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	local wc:WNDCLASSEX
	local	msg:MSG
	local	hwnd:HWND
	mov wc.cbSize,sizeof wc
	mov wc.style,0
	mov wc.lpfnWndProc, offset WndProc
	mov wc.cbClsExtra,0
	mov wc.cbWndExtra,0
	mov eax,hInst
	mov wc.hInstance,eax
	mov wc.hbrBackground,COLOR_WINDOW
	mov wc.lpszMenuName,0
	mov wc.lpszClassName,offset _wnd
	invoke LoadIcon,0,IDI_QUESTION
	mov wc.hIcon,eax
	mov wc.hIconSm,eax
	invoke LoadCursor,0,IDC_ARROW
	mov wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	invoke CreateWindowEx,WS_EX_CLIENTEDGE,offset _wnd,offset _wnd,WS_OVERLAPPEDWINDOW,20,20,300,200,0,0,hInst,0
	mov hwnd,eax
	invoke ShowWindow,hwnd,CmdShow
	invoke UpdateWindow,hwnd
	.while TRUE
		invoke GetMessage,addr msg,0,0,0
		.break .if (!eax)
		invoke TranslateMessage,addr msg
		invoke DispatchMessage,addr msg
	.endw
	mov eax,msg.wParam
	ret
WinMain endp

start:
	invoke GetModuleHandle,0
	mov hinst,eax
	invoke WinMain,eax,0,0,SW_SHOWDEFAULT
	invoke ExitProcess,eax
end start
